import openpyxl as px
import time
import random
import os
import multiprocessing
import fishtreesrundatastructs as ftds
import networkx as nx
#from decisiontreeutilsforcancerphylo import *
import decisiontreeutilsforcancerphylo as dtufcp
from decisiontreeutilsforcancerphylo import node,treedata,nulllinetoinitiatenode
#%% 


cpcr=dtufcp.checkparentchildrelation

#%% 

print 'finding inital excel file'
filename='preprocessMSdata.xlsx'
#original tree A from 2005 paper in 2015
selectedsheet='tables2a'
#simpletest1
#selectedsheet='simpletest1'
#simpletest2
#selectedsheet='simpletest2'
#simpletest3
#selectedsheet='simpletest3'

W = px.load_workbook(filename, use_iterators = True)
p = W.get_sheet_by_name(name = selectedsheet)

print 'loading text data from excel file'
data= ftds.turnexceldatain2dlist(p)
print 'finished loading text data from excel file'
#%% 
print 'Get names of MS'
#define various parameters for the simulation
"""add rerooted tree with all features labeled"""
global allrundata, sizeofsubset,numtrials,sizeofallfeatures,countadjustment,simplerootname,lenofrow,lenofcol,referencecelltypenames,edgecounter,times,os,ti
numtrials=1000
sizeofallfeatures=37
sizeofsubset=22#22



allrundata=[ftds.FishTreesRun() for trial in xrange(numtrials)]
countadjustment=3# haploid offset to prevent negative counts
simplerootname=u"Root"

assert(numtrials>0)

lenofrow=len(data[2])
lenofcol=len(data)
referencecelltypenames=[]
# define names of cell types
for namepos in xrange(2,lenofrow,2):referencecelltypenames.append(data[1][namepos])
# and make dictionary to count number of edges
edgecounter=ftds.makeedgecounter(referencecelltypenames)
#print edgecounter

topdirectory='currentwork'
if not os.path.exists(topdirectory):os.makedirs(topdirectory)
os.chdir(topdirectory)
#%% 
times=[]
ti=time.time()

def dofishtreesrun(trial):#addness variables
#for trial in xrange(numtrials):
    #break
    print "Trial number:",trial
    newfolder='randomfishtreestrial%d'%(trial)
    if not os.path.exists(newfolder):os.makedirs(newfolder)
    os.chdir(newfolder)    
    # define importatn data structures for this replicate
    MSselected=ftds.pickrandommarkersubset(random,sizeofallfeatures,sizeofsubset)
    intiallistofMSCPVnames=[]
    for entry in xrange(2,len(data)):intiallistofMSCPVnames.append(str(data[entry][0]))
    listofMSCPVnames=[intiallistofMSCPVnames[pos] for pos in MSselected]#all selected markers for run    
    listofdefaultcopynumbervalues= [countadjustment] * len(listofMSCPVnames)
    dicofrawcelldata={}
    chromoprobes=['CEP1']#dummy used to format data for fishtrees
#%%     
    # dicofrawcelldata [all cell types] [all markers], bottom level is diploid tuple
    for namepos in xrange(2,lenofrow,2):
        name = data[1][namepos]
        allrundata[trial].celltypenames.append(name)
        dicofrawcelldata[name]={}
        for MSCPV in listofMSCPVnames:
            MSpos=2+intiallistofMSCPVnames.index(MSCPV)
            dicofrawcelldata[name][MSCPV]=(data[MSpos][namepos],data[MSpos][namepos+1])    
    
    dicofcelldata={}
    
    #dicofcelldata bottom level is sum of all counts for marker for cell type, int
    for name in dicofrawcelldata:
        dicofcelldata[name]={}
        for CPVname in dicofrawcelldata[name]:
           dicofcelldata[name][CPVname] =((listofdefaultcopynumbervalues[listofMSCPVnames.index(CPVname)]+
                                           dicofrawcelldata[name][CPVname][0])+
                                          (listofdefaultcopynumbervalues[listofMSCPVnames.index(CPVname)]+
                                           dicofrawcelldata[name][CPVname][1]))# add a value to each entry to make them all positive and add together both values to get total copy number
        for cprobe in chromoprobes:dicofcelldata[name][cprobe]=2*countadjustment#so the rootcountsmatch the chromosome counter-#old2# always diploid
    
    allrundata[trial].dicofprocesseddata=dicofcelldata    
    geneprobes=list(listofMSCPVnames)
    allrundata[trial].geneprobesnames=geneprobes
#%%     
    firstline=str(len(chromoprobes))+'\t'+'\t'.join(chromoprobes)+'\t'+str(len(geneprobes))+'\t'+'\t'.join(geneprobes)+'\n' # chnage for more probes
    otherlines=''    
    cellcounter=0
    for celltype in dicofcelldata:
        nextline=''
        for cprobe in chromoprobes:nextline+=(str(dicofcelldata[celltype][cprobe])+'\t')
        for gprobe in geneprobes:nextline+=(str(dicofcelldata[celltype][gprobe])+'\t')
        nextline=nextline+'1\n'# add 1 to ends to always mean that there is only 1 cell per type
        otherlines+=nextline
        cellcounter+=1
        
    secondline=str(len(dicofcelldata.keys()))+'\t'+str(cellcounter) +'\n'    
    foldertoworkin='trialdata'
    if not os.path.exists(foldertoworkin):os.makedirs(foldertoworkin)
    currentfiletowrite=foldertoworkin +'/treeinfishformat.txt'
    currentCNVdata=open(currentfiletowrite,'w')
    currentCNVdata.write(firstline)
    currentCNVdata.write(secondline)
    currentCNVdata.write(otherlines)
    currentCNVdata.close()    

    initialcommandline="fishplusmax32 trialdata/"    
    allrundata[trial].commandlinestr+=initialcommandline    
    recordoffishtreecommandlineinputs='reffishtreecommandlineinputs.txt'
    fishtreecommandref=open(recordoffishtreecommandlineinputs,'a')
    fishtreecommandref.write(time.strftime("%c")+'\n')
    fishtreecommandref.write(initialcommandline)
    for cprobe in chromoprobes:
        fishtreecommandref.write((' '+cprobe+' ').join((['']+listofMSCPVnames)))
        allrundata[trial].commandlinestr+=(' '+cprobe+' ').join((['']+listofMSCPVnames))
    fishtreecommandref.write(" X\n")
    allrundata[trial].commandlinestr+=" -2\n"
    fishtreecommandref.close()
#%% 
    print allrundata[trial].commandlinestr
    os.system(allrundata[trial].commandlinestr)
            
    dottoreadandeditname=os.getcwd() +'/'+ ftds.findfilename(os)
    treedforfeatures=dtufcp.readdotdot(dottoreadandeditname)
    
    #print treedforfeatures.tree.nodes()
    #print '\n\n\n\n'*2

#%% 
    """directededges=nx.bfs_successors(treedforfeatures.tree,simplerootname)     
    rerootedtd=dtufcp.reroottreedata(treedforfeatures,directededges)
    editeddotfile="isrerootedwithallfeatures".join(dottoreadandeditname.split('.txt'))
    dtufcp.writetodotdot(treedforfeatures,editeddotfile)"""
    
    #dottoreadandeditname=os.getcwd() +'/'+ ftds.findfilename(os)
    treed=dtufcp.readdotdot(dottoreadandeditname)
    
    #print treedforfeatures.tree.nodes()
    #print '\n\n\n\n'*2
    
    def showallnodesintreeanddic(treeda):
        print "dic nodes"
        for i in treeda.dic: print i
        print '\n'*2
        print "tree nodes"
        for i in treeda.tree.nodes():print i
        print '\n'*2
        
    def print2treedataobjs(ob1,name1,ob2,name2):
        #print name1
        #showallnodesintreeanddic(ob1)
        print name2
        showallnodesintreeanddic(ob2)
        return "\n"
    
#%%     
    #dtufcp.printallnodes(cpcr,treed)    
    renamedic={}  
    for celltype in allrundata[trial].celltypenames:
        for treenode in treed.dic:
            #print treed.dic[node].probenum
            #print "Step1: celltype=", celltype, " treenode=", treenode, '\n', print2treedataobjs(treed,"treed",treedforfeatures,"treedforfeatures")
            if "(" in treed.dic[treenode].probenum:processprobe=dtufcp.parseprobenumstr(treed.dic[treenode].probenum)
            else:
                continue
            #print processprobe
            if dtufcp.comparedics(processprobe,allrundata[trial].dicofprocesseddata[celltype]):
                #print treed.dic[treenode].probenum, celltype
                if celltype==simplerootname:
                    print treedforfeatures.dic[treenode].probenum
                    #print '\n\n\n\n'*2
                    oldrootfeaturename=treedforfeatures.dic[treenode].probenum
                treed.dic[treenode].probenum=celltype
                renamednode=treed.dic.pop(treenode)
                treed.dic[celltype]=renamednode
                for currentnode in treed.dic:
                    if (treed.dic[currentnode].pname==treenode):
                        treed.dic[currentnode].pname=celltype
                    if treenode in treed.dic[currentnode].chnames:
                      #  print treed.dic[currentnode].chnames
                        postoreplace=(treed.dic[currentnode].chnames).index(treenode)
                        treed.dic[currentnode].chnames=(treed.dic[currentnode].chnames)[0:postoreplace]+[celltype]+(treed.dic[currentnode].chnames)[postoreplace+1:]       
                #dtufcp.printallnodes(cpcr,treed)
                #break
                renamedic[treenode]=celltype
    #print "after: ", print2treedataobjs(treed,"treed",treedforfeatures,"treedforfeatures")
    #print renamedic
    #print treed.tree.nodes()
    #print treed.dic.keys()
    #print treedforfeatures.tree.nodes()
    #print treedforfeatures.dic.keys()
    #print '\n\n\n\n'*2
    
    treed.tree=nx.relabel_nodes(treed.tree,renamedic,copy=True) 
    
    print "# cell types:", allrundata[trial].celltypenames
    print "all celltypes in tree:", len(treed.tree.nodes())
    print "all celltypes in dic:", len(treed.dic.keys())
    presentcelltypes={}
    for ct in treed.tree.nodes():presentcelltypes[ct]=[ct]
        
    def compareprofileof2celltypes(t1,t2):
        same=True
        for i in set(t1.keys()+t2.keys()):
            try:
                if t1[i]==t2[i]:
                    same=True
                else:
                    same=False
                    return same
            except:
                same=False
                return same
        return same
        
    for celltype in dicofcelldata:
        for ct in presentcelltypes:
            if celltype!=ct:
                if '\\n' not in ct:
                    if compareprofileof2celltypes(dicofcelldata[celltype],dicofcelldata[ct]):
                        presentcelltypes[ct]=presentcelltypes[ct]+[celltype]
                        
    for ct in presentcelltypes: print ct, len(presentcelltypes[ct]),presentcelltypes[ct] 
    #print "after2: ", print2treedataobjs(treed,"treed",treedforfeatures,"treedforfeatures")
    #print renamedic
    #print treed.tree.nodes()
    #print treed.dic.keys()
    #print treedforfeatures.tree.nodes()
    #print treedforfeatures.dic.keys()
    #print '\n\n\n\n'*2
    #for n in treed.tree.nodes():# prevent a weird error where a node that is not supoosed to be in tree is added 
    #    if n not in treed.dic:
    #        treed.tree.remove_node(n)
    #dtufcp.printallnodes(cpcr,treed)
    
    #print oldrootfeaturename
    #print treedforfeatures.tree.nodes()
    directededges=nx.bfs_successors(treedforfeatures.tree,oldrootfeaturename)     
    treedforfeatures=dtufcp.reroottreedata(treedforfeatures,directededges)
    editeddotfile="isrerootedwithallfeatures".join(dottoreadandeditname.split('.txt'))
    dtufcp.writetodotdot(treedforfeatures,editeddotfile) 
#%%             
    editeddotfile="thatiseditedwithcelltypenames".join(dottoreadandeditname.split('.txt'))
    dtufcp.writetodotdot(treed,editeddotfile)    
#%% 
    directededges=nx.bfs_successors(treed.tree,simplerootname)     
    rerootedtd=dtufcp.reroottreedata(treed,directededges)
#%%     
    allrundata[trial].storetreeresult=rerootedtd
#%% 
    editeddotfile="rerootededitedwithcelltypenames".join(dottoreadandeditname.split('.txt'))
    dtufcp.writetodotdot(rerootedtd,editeddotfile)
        
    os.chdir('..')
    
    for nodepair in edgecounter:
        if nodepair[1] in rerootedtd.tree:
            if nodepair[0] in rerootedtd.tree[nodepair[1]]:
                edgecounter[nodepair]+=1
    
    print "done with trial number:",trial
    #newtime=time.time()
    #times.append(newtime-ti)
    #ti=newtime
    


#t=time.time()

pool = multiprocessing.Pool(processes=multiprocessing.cpu_count()-2)
results = pool.map(dofishtreesrun, xrange(numtrials))

#print('It took {} seconds'.format(time.time() - t))
    
#%%     
    
cutoff=(numtrials/2.0)*(.99)#adujust for rounding error
consensustree=nx.Graph()
consensustree.add_nodes_from(referencecelltypenames)
#print consensustree.nodes()
for nodepair in edgecounter:
    if edgecounter[nodepair]>cutoff:
       consensustree.add_edge(nodepair[0], nodepair[1], weight=float(edgecounter[nodepair])/numtrials)
#%% 
ctree=treedata(consensustree)
directededges=nx.bfs_successors(ctree.tree,simplerootname) # erorr when root is not connect to tree no tree gets recorded
#make blank nodes to  then have edges added in and effective rooted in representation though the graph is n0t directional
for celltype in referencecelltypenames:ctree.dic[celltype]=dtufcp.makeblanknode(-1,len(referencecelltypenames),celltype,nulllinetoinitiatenode)
#%% 
for startn in directededges:
    for endn in directededges[startn]:
        #print startn, endn
        sn=ctree.dic[startn]
        en=ctree.dic[endn]
        en.addparent(sn,ctree.tree[startn][endn])

#to save consensus tree
#import pickle
#fil=open('ctreeref.pkl')
#ctree=pickle.load(fil)

        
dtufcp.writetodotdot(ctree,"ConsensusTree..dot")
print "done with consensustree"
os.chdir('..')     


